﻿using System;
using System.Windows.Forms;

using AIOUSBNet;  // the namespace exposes the AIOUSB Class interface 

namespace Sample1
{
    public partial class Form1 : Form
    {
        public UInt32 DeviceIndex;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Called before Form is displayed Initialize resources:
            DeviceIndex = AIOUSB.diOnly;

            UInt32 ERROR_SUCCESS = 0;
            UInt32 Status;
            int deviceCount = 0;

            // Get The Device Information test for devices found:
            for (DeviceIndex = 0; DeviceIndex < 32; DeviceIndex++)
            {
                Status = AIOUSB.QueryDeviceInformation(DeviceIndex, out _, out _, out string strName, out _, out _);
                if (Status != ERROR_SUCCESS) continue;

                Status = AIOUSB.GetDeviceSerialNumber(DeviceIndex, out ulong SerNum);
                if (Status != ERROR_SUCCESS)
                    SerNum = 0;

                DeviceListBox.Items.Add("Device at DeviceIndex[" + DeviceIndex.ToString() + "] is a '" + strName + "' ( SN= " + SerNum.ToString("X") + " )");

                deviceCount++;
            }
            DeviceListBox.Items.Add(string.Format("{0} device{1} detected.", deviceCount, (deviceCount != 1) ? "s" : ""));
            if (deviceCount == 0)
                DeviceListBox.Items.Add("Please check Device Manager to confirm your devices are properly installed.");
            DeviceListBox.Items.Add("Done.");
        }
    }
}
